//////////////////////////////////////////////////
//////////////Shadow Combine Shader///////////////
//////////////////////////////////////////////////
//////////////////////////////////////////////////
////24.12.2008////////////////by Nils Daumann/////
///////////////www.ssmasters.de///////////////////
//////////////////////////////////////////////////

float4 vecSkill1;
float4 vecSkill5;

Texture TargetMap;
Texture mtlSkin1;
Texture mtlSkin2;
Texture mtlSkin3;
Texture mtlSkin4;

sampler colMap = sampler_state
{
	texture = <TargetMap>;
	magfilter = LINEAR;
	minfilter = LINEAR;
	mipfilter = LINEAR;
	AddressU = clamp;
	AddressV = clamp;
};

sampler shad1Map = sampler_state
{
	texture = <mtlSkin1>;
	magfilter = LINEAR;
	minfilter = LINEAR;
	mipfilter = LINEAR;
	AddressU = clamp;
	AddressV = clamp;
};

sampler shad2Map = sampler_state
{
	texture = <mtlSkin2>;
	magfilter = LINEAR;
	minfilter = LINEAR;
	mipfilter = LINEAR;
	AddressU = clamp;
	AddressV = clamp;
};

sampler shad3Map = sampler_state
{
	texture = <mtlSkin3>;
	magfilter = LINEAR;
	minfilter = LINEAR;
	mipfilter = LINEAR;
	AddressU = clamp;
	AddressV = clamp;
};

sampler shad4Map = sampler_state
{
	texture = <mtlSkin4>;
	magfilter = LINEAR;
	minfilter = LINEAR;
	mipfilter = LINEAR;
	AddressU = clamp;
	AddressV = clamp;
};

float4 ps_main(float2 TexCoord : TEXCOORD0_centroid) : COLOR0
{
	float4 Color = tex2D(colMap,TexCoord);
	
	float4 Shad1 = tex2D(shad1Map,TexCoord);
	float4 Shad2 = tex2D(shad2Map,TexCoord);
	float4 Shad3 = tex2D(shad3Map,TexCoord);
	float4 Shad4 = tex2D(shad4Map,TexCoord);
	
	float3 Shadow = saturate(vecSkill5.x+
									Shad1.r-(Shad1.g*saturate(vecSkill1.y+vecSkill1.z+vecSkill1.w))+
									Shad2.r+
									Shad3.rgb-(Shad3.a*saturate(vecSkill1.y+vecSkill1.x+vecSkill1.w))+
									Shad4.rgb-(Shad4.a*saturate(vecSkill1.y+vecSkill1.x+vecSkill1.z))+
									saturate(1.0-((1.0-Shad1.g)*vecSkill1.x)-((1.0-Shad3.a)*vecSkill1.z)-((1.0-Shad4.a)*vecSkill1.w))*(1.0-vecSkill1.y));
	return Color*float4(Shadow,1.0);
}

technique Main
{
	pass RenderShadowMap
	{
		PixelShader = compile ps_2_0 ps_main();
	}
}
