//////////////////////////////////////////////////
////////////Spotlight Shadowmapping///////////////
//////////////////////////////////////////////////
//////////////////////////////////////////////////
////24.12.2008////////////////by Nils Daumann/////
///////////////www.ssmasters.de///////////////////
//////////////////////////////////////////////////

#ifndef SM_SPOTLIGHTS
#define SM_SPOTLIGHTS

var SM_Spot_Active_var = 0;

float SM_Spot_matrix[32];

MATERIAL* SM_Spot_Main_mat =
{
	effect = "SM_SpotLights_main.fx";
}

MATERIAL* SM_Spot_Depth_mat =
{
	effect = "SM_VSM_depth.fx";
}

#ifndef SM_COMBINE
#define SM_COMBINE
	MATERIAL* SM_Combine_mat =
	{
		effect = "SM_Combine.fx";
	}
#endif

void SM_Spot_getViewProj()
{
	mat_effect1 = &SM_Spot_matrix[0];
	mat_effect2 = &SM_Spot_matrix[16];
	
	mat_set(mtl.matrix,matView);
	mat_multiply(mtl.matrix,matProj);
	if(render_view.layer == -2)
	{
		mat_set(SM_Spot_matrix[0],mtl.matrix);
	}else
	{
		mat_set(SM_Spot_matrix[16],mtl.matrix);
	}
}

void SM_Spot_setViewProj()
{
	if(mtl.skin2 == NULL && mtl.skin4 == NULL){return;}
	
	float fTexAdj[16] =
	{
		0.5, 0.0, 0.0, 0.0,
		0.0,-0.5, 0.0, 0.0,
		0.0, 0.0, 1.0, 0.0,
		0.0, 0.0, 0.0, 1.0
	};
	
	if(mtl.skin2 == NULL)
	{
		fTexAdj[12] = 0.5 + (0.5/floatv(mtl.skin4.width));
		fTexAdj[13] = 0.5 + (0.5/floatv(mtl.skin4.height));
	}else
	{
		fTexAdj[12] = 0.5 + (0.5/floatv(mtl.skin2.width));
		fTexAdj[13] = 0.5 + (0.5/floatv(mtl.skin2.height));
	}
	
	mat_multiply(SM_Spot_matrix[0],fTexAdj);
	mat_multiply(SM_Spot_matrix[16],fTexAdj);
	
	mat_effect1 = &SM_Spot_matrix[0];
	mat_effect2 = &SM_Spot_matrix[16];
}

void SM_Spot_delete()
{
	SM_Spot_Active_var = 0;
}

void SM_CreateSpotlights(var resolution, ENTITY* ent1, ENTITY* ent2)
{
	SM_Spot_delete();
	wait(1);
	
	if((ent1 == NULL && ent2 == NULL) || resolution == 0)
		return;
	
	if(ent1 == NULL)
	{
		ent1 = ent2;
		ent2 = NULL;
	}
	
	proc_mode = PROC_LATE;
	
	VIEW* mainview;
	mainview = view_create(-1);
	
	VIEW* depth1view = NULL;
	VIEW* depth2view = NULL;
	
	if(ent1 != NULL)
	{
		SM_Spot_Main_mat.skin1 = ent_getskin(ent1,1);
		SM_Spot_Main_mat.skin2 = bmap_createblack(resolution,resolution,14444);
		
		depth1view = view_create(-2);
		depth1view.material = SM_Spot_Depth_mat;
		depth1view.bmap = SM_Spot_Main_mat.skin2;
		depth1view.size_x = resolution;
		depth1view.size_y = resolution;
		set(depth1view,VISIBLE);
	}
	
	if(ent2 != NULL)
	{
		SM_Spot_Main_mat.skin3 = ent_getskin(ent2,1);
		SM_Spot_Main_mat.skin4 = bmap_createblack(resolution,resolution,14444);
		
		depth2view = view_create(-3);
		depth2view.material = SM_Spot_Depth_mat;
		depth2view.bmap = SM_Spot_Main_mat.skin4;
		depth2view.size_x = resolution;
		depth2view.size_y = resolution;
		set(depth2view,VISIBLE);
	}
	
	mainview.material = SM_Spot_Main_mat;
	mainview.size_x = screen_size.x;
	mainview.size_y = screen_size.y;
	SM_Combine_mat.skin4 = bmap_createblack(screen_size.x,screen_size.y,32);
	mainview.bmap = SM_Combine_mat.skin4;
	set(mainview,VISIBLE);
	
	SM_Spot_Main_mat.event = SM_Spot_setViewProj;
	SM_Spot_Depth_mat.event = SM_Spot_getViewProj;
	set(SM_Spot_Main_mat,ENABLE_VIEW);
	set(SM_Spot_Depth_mat,ENABLE_VIEW);
	
	PP_Remove(SM_Combine_mat,camera,NULL);
	PP_Add(SM_Combine_mat,camera,NULL);
	
	SM_Combine_mat.skill4 = floatv(1);
	
	SM_Spot_Active_var = 1;
	while(SM_Spot_Active_var)
	{
		vec_set(mainview.x,camera.x);
		vec_set(mainview.pan,camera.pan);
		mainview.genius = camera.genius;
		mainview.clip_near = camera.clip_near;
		mainview.clip_far = camera.clip_far*0.2;
		mainview.arc = camera.arc;
		
		if(ent1 != NULL)
		{
			SM_Spot_Main_mat.skin1 = ent_getskin(ent1,1);
			vec_set(depth1view.x,ent1.x);
			vec_set(depth1view.pan,ent1.pan);
			depth1view.clip_far = ent1.skill1;
			depth1view.arc = ent1.skill3;
			depth1view.aspect = ent1.skill4;
			SM_Spot_Main_mat.skill17 = floatv(ent1.skill2);
			SM_Spot_Main_mat.skill1 = floatv(ent1.x);
			SM_Spot_Main_mat.skill2 = floatv(ent1.z);
			SM_Spot_Main_mat.skill3 = floatv(ent1.y);
			SM_Spot_Main_mat.skill4 = floatv(ent1.skill1);
		}
		
		if(ent2 != NULL)
		{
			SM_Spot_Main_mat.skin3 = ent_getskin(ent2,1);
			vec_set(depth2view.x,ent2.x);
			vec_set(depth2view.pan,ent2.pan);
			depth2view.clip_far = ent2.skill1;
			depth2view.arc = ent2.skill3;
			depth2view.aspect = ent2.skill4;
			SM_Spot_Main_mat.skill18 = floatv(ent2.skill2);
			SM_Spot_Main_mat.skill5 = floatv(ent2.x);
			SM_Spot_Main_mat.skill6 = floatv(ent2.z);
			SM_Spot_Main_mat.skill7 = floatv(ent2.y);
			SM_Spot_Main_mat.skill8 = floatv(ent2.skill1);
		}
		
		wait(1);
	}
	
	SM_Combine_mat.skill4 = floatv(0);
	
	ptr_remove(SM_Spot_Main_mat.skin3);
	ptr_remove(SM_Spot_Main_mat.skin4);
	
	ptr_remove(mainview.bmap);
	ptr_remove(mainview);
}

#endif
